    View Javadoc
    1   package org.apache.bcel.generic;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56  import org.apache.bcel.Constants;
    57
    58  /***
    59   * Denotes array type, such as int[][]
    60   *
    61   * @version $Id: ArrayType.java,v 1.1.1.1 2001/10/29 20:00:06 jvanzyl Exp $
    62   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    63   */
    64  public final class ArrayType extends ReferenceType {
    65    private int  dimensions;
    66    private Type basic_type;
    67
    68    /***
    69     * Convenience constructor for array type, e.g. int[]
    70     *
    71     * @param type array type, e.g. T_INT
    72     */
    73    public ArrayType(byte type, int dimensions) {
    74      this(BasicType.getType(type), dimensions);
    75    }
    76
    77    /***
    78     * Convenience constructor for reference array type, e.g. Object[]
    79     *
    80     * @param class_name complete name of class (java.lang.String, e.g.)
    81     */
    82    public ArrayType(String class_name, int dimensions) {
    83      this(new ObjectType(class_name), dimensions);
    84    }
    85
    86    /***
    87     * Constructor for array of given type
    88     *
    89     * @param type type of array (may be an array itself)
    90     */
    91    public ArrayType(Type type, int dimensions) {
    92      super(Constants.T_ARRAY, "<dummy>");
    93
    94      if((dimensions < 1) || (dimensions > Constants.MAX_BYTE))
    95        throw new ClassGenException("Invalid number of dimensions: " + dimensions);
    96
    97      switch(type.getType()) {
    98      case Constants.T_ARRAY:
    99        ArrayType array = (ArrayType)type;
    100       this.dimensions = dimensions + array.dimensions;
    101       basic_type      = array.basic_type;
    102       break;
    103
    104     case Constants.T_VOID:
    105       throw new ClassGenException("Invalid type: void[]");
    106
    107     default: // Basic type or reference
    108       this.dimensions = dimensions;
    109       basic_type = type;
    110       break;
    111     }
    112
    113     StringBuffer buf = new StringBuffer();
    114     for(int i=0; i < this.dimensions; i++)
    115       buf.append('[');
    116
    117     buf.append(basic_type.getSignature());
    118
    119     signature = buf.toString();
    120   }
    121
    122   /***
    123    * @return basic type of array, i.e., for int[][][] the basic type is int
    124    */
    125   public Type getBasicType() {
    126     return basic_type;
    127   }
    128
    129   /***
    130    * @return element type of array, i.e., for int[][][] the element type is int[][]
    131    */
    132   public Type getElementType() {
    133     if(dimensions == 1)
    134       return basic_type;
    135     else
    136       return new ArrayType(basic_type, dimensions - 1);
    137   }
    138
    139   /*** @return number of dimensions of array
    140    */
    141   public int getDimensions() { return dimensions; }
    142
    143   /*** @return a hash code value for the object.
    144    */
    145   public int hashcode() { return basic_type.hashCode() ^ dimensions; }
    146
    147   /*** @return true if both type objects refer to the same array type.
    148    */
    149   public boolean equals(Object type) {
    150     if(type instanceof ArrayType) {
    151       ArrayType array = (ArrayType)type;
    152       return (array.dimensions == dimensions) && array.basic_type.equals(basic_type);
    153     } else
    154       return false;
    155   }
    156 }

This page was automatically generated by Maven